package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10059JiHuoReasult;
import cn.net.cpzslibs.prot.handset.bean.Prot10059SendBeanYTH;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10059JiHuoYTH extends ProtBase {
	private short iResult;

	private final short iTaskCode10059 = 10059;

	private Gson gson;

	private Prot10059JiHuoReasult res;

	public Prot10059JiHuoYTH() {
		gson = new Gson();
	}

	public Prot10059JiHuoReasult getRes() {
		return res;
	}

	public void setRes(Prot10059JiHuoReasult res) {
		this.res = res;
	}

	public void dealJiHuo(SocketCreate create,
                          Prot10059SendBeanYTH ythBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), ythBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10059SendBeanYTH ythBean)
			throws IOException {
		if (socket.isConnected()) {

			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10059, "开始发送登录信息");
				sendProt(dos, ythBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10059SendBeanYTH ythBean)
			throws IOException {
		String bodyContent = gson.toJson(ythBean).toString();
		System.out.println("---json" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10059, bodySize);//84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10059, "获取接收的数据");
		recHeader(dis);
	
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10059, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10059JiHuoReasult.class);
		}
		recCheckCode(dis);
	}

}
